Index: trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.Designer.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.Designer.cs	(revision 16204)
+++ trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.Designer.cs	(revision 16205)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Windows.Forms;
 using HeuristicLab.Data.Views;
 
@@ -50,4 +51,7 @@
       this.refreshButton = new System.Windows.Forms.Button();
       this.removeButton = new System.Windows.Forms.Button();
+      this.startButton = new System.Windows.Forms.Button();
+      this.stopButton = new System.Windows.Forms.Button();
+      this.pauseButton = new System.Windows.Forms.Button();
       this.matrixView = new HeuristicLab.Data.Views.StringConvertibleMatrixView();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
@@ -75,4 +79,41 @@
       this.removeButton.UseVisualStyleBackColor = true;
       this.removeButton.Click += new System.EventHandler(this.removeButton_Click);
+      // 
+      // startButton
+      // 
+      this.startButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.startButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Play;
+      this.startButton.Location = new System.Drawing.Point(0, 564);
+      this.startButton.Name = "startButton";
+      this.startButton.Size = new System.Drawing.Size(24, 24);
+      this.startButton.TabIndex = 4;
+      this.toolTip.SetToolTip(this.startButton, "Resume job(s)");
+      this.startButton.UseVisualStyleBackColor = true;
+      this.startButton.Click += new System.EventHandler(this.startButton_Click);
+      // 
+      // pauseButton
+      // 
+      this.pauseButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.pauseButton.Enabled = false;
+      this.pauseButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Pause;
+      this.pauseButton.Location = new System.Drawing.Point(30, 564);
+      this.pauseButton.Name = "pauseButton";
+      this.pauseButton.Size = new System.Drawing.Size(24, 24);
+      this.pauseButton.TabIndex = 5;
+      this.toolTip.SetToolTip(this.pauseButton, "Pause job(s)");
+      this.pauseButton.UseVisualStyleBackColor = true;
+      this.pauseButton.Click += new System.EventHandler(this.pauseButton_Click);
+      // 
+      // stopButton
+      // 
+      this.stopButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.stopButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Stop;
+      this.stopButton.Location = new System.Drawing.Point(60, 564);
+      this.stopButton.Name = "stopButton";
+      this.stopButton.Size = new System.Drawing.Size(24, 24);
+      this.stopButton.TabIndex = 6;
+      this.toolTip.SetToolTip(this.stopButton, "Stop job(s)");
+      this.stopButton.UseVisualStyleBackColor = true;
+      this.stopButton.Click += new System.EventHandler(this.stopButton_Click);
       // 
       // matrixView
@@ -110,4 +151,7 @@
     private System.Windows.Forms.Button refreshButton;
     private System.Windows.Forms.Button removeButton;
+    private System.Windows.Forms.Button startButton;
+    private System.Windows.Forms.Button stopButton;
+    private System.Windows.Forms.Button pauseButton;
     private StringConvertibleMatrixView matrixView;
   }
Index: trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.cs	(revision 16204)
+++ trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.cs	(revision 16205)
@@ -132,4 +132,16 @@
         }
       } 
+    }
+
+    private async void startButton_Click(object sender, EventArgs e) {
+      throw new NotImplementedException();
+    }
+
+    private async void pauseButton_Click(object sender, EventArgs e) {
+      throw new NotImplementedException();
+    }
+
+    private async void stopButton_Click(object sender, EventArgs e) {
+      throw new NotImplementedException();
     }
 
@@ -201,4 +213,20 @@
     }
 
+    private void PauseJobs(List<Guid> jobIds) {
+      try {
+        // TODO
+      } catch (AnonymousUserException) {
+        ShowHiveInformationDialog();
+      }
+    }
+
+    private void StopJobs(List<Guid> jobIds) {
+      try {
+        // TODO
+      } catch (AnonymousUserException) {
+        ShowHiveInformationDialog();
+      }
+    }
+
     private void DeleteJobs(List<Guid> jobIds) {
       try {
Index: trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelector.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelector.cs	(revision 16204)
+++ trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelector.cs	(revision 16205)
@@ -284,5 +284,4 @@
         }
       }
-
     }
 
Index: trunk/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame	(revision 16204)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame	(revision 16205)
@@ -30,4 +30,5 @@
   [PluginFile("HeuristicLab.Clients.Hive-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Clients.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Clients.Access", "3.3")]  
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]